﻿@{
    ViewBag.Title = "Dashboard";
}

<div class="content">
    <div class="row">
        <div class="col-md-12">
            <div class="profile-picture">
                <a href="@Url.Action("Index", "Dashboard")">
                    <img src="~/Images/a2.jpg" class="img-circle m-b" alt="logo">
                </a>

                <div class="stats-label text-color">
                    <span class="font-extra-bold font-uppercase">John Smith</span>

                    <div class="dropdown">
                        <a class="dropdown-toggle" href="#" data-toggle="dropdown">
                            <small class="text-muted">Your grandpa <b class="caret"></b></small>
                        </a>
                    </div>

                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-lg-12">
            <div class="hpanel">
                <div class="panel-heading">
                    <div class="panel-tools">
                        <a class="showhide"><i class="fa fa-chevron-up"></i></a>
                        <a class="closebox"><i class="fa fa-times"></i></a>
                    </div>
                    Dashboard
                </div>
                <div class="panel-body">
                    <div class="row">
                        <div class="col-md-3 text-center">
                            <h3>Current pulse</h3>
                            <h1 class="font-extra-bold m-t-xl m-b-xs">
                                <i class="fa fa-heart"></i><span id="pulseValue"> 65</span> BPM
                            </h1>
                            <small>Last measured pulse value</small>

                            @*<div class="small m-t-xl">
                                <i class="fa fa-clock-o"></i> Data from January
                            </div>*@
                        </div>
                        <div class="col-md-6">
                            @*<div class="text-center small">
                                <i class="fa fa-laptop"></i> Active users in current month (December)
                            </div>*@
                            <div class="flot-chart" style="height: 160px">
                                <div class="flot-chart-content" id="flot-line-chart"></div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="panel-footer">

                    Last update: @DateTime.Now
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-lg-12">
            <div class="hpanel">
                <div class="panel-heading">
                </div>
                <div class="panel-body" style="min-height:200px; width:100%;">
                    <div id="map" style="height:400px; width:100%;"></div>
                </div>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col-lg-12">
            <div class="hpanel stats">
                <div class="panel-body h-200">
                    <div class="stats-title pull-left">
                        <h4>Current activity</h4>
                    </div>
                    <div class="stats-icon pull-right">
                        <i class="pe-7s-share fa-4x"></i>
                    </div>
                    <div style="margin-top: 100px" id="timeline" class="v-timeline vertical-container animate-panel" data-child="vertical-timeline-block" data-delay="1">
                        <div class="vertical-timeline-block">
                            <div class="vertical-timeline-icon navy-bg">
                                <i class="fa fa-calendar"></i>
                            </div>
                            <div class="vertical-timeline-content">
                                <div class="p-sm">
                                    @*<span class="vertical-date pull-right"> Saturday <br /> <small>12:17:43 PM</small> </span>    *@

                                    <h4>Location 1 - @DateTime.Now</h4>
                                    <p>
                                        Lorem Ipsum is simply dummy text of the printing and typesetting industry.
                                    </p>
                                </div>
                                <div class="panel-footer">
                                    Show this activity on the map
                                </div>
                            </div>
                        </div>


                        <div class="vertical-timeline-block">
                            <div class="vertical-timeline-icon navy-bg">
                                <i class="fa fa-calendar"></i>
                            </div>
                            <div class="vertical-timeline-content">
                                <div class="p-sm">
                                    @*<span class="vertical-date pull-right"> Saturday <br /> <small>12:17:43 PM</small> </span>    *@

                                    <h4>Location 2 - @DateTime.Now</h4>
                                    <p>
                                        Lorem Ipsum is simply dummy text of the printing and typesetting industry.
                                    </p>
                                </div>
                                <div class="panel-footer">
                                    Show this activity on the map
                                </div>
                            </div>
                        </div>

                        <div class="vertical-timeline-block">
                            <div class="vertical-timeline-icon navy-bg">
                                <i class="fa fa-calendar"></i>
                            </div>
                            <div class="vertical-timeline-content">
                                <div class="p-sm">
                                    @*<span class="vertical-date pull-right"> Saturday <br /> <small>12:17:43 PM</small> </span>    *@

                                    <h4>Location 3 - @DateTime.Now</h4>
                                    <p>
                                        Lorem Ipsum is simply dummy text of the printing and typesetting industry.
                                    </p>
                                </div>
                                <div class="panel-footer">
                                    Show this activity on the map
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="panel-footer">
                    Standard footer
                </div>
            </div>
        </div>
    </div>
</div>

@section Styles {
    @Styles.Render("~/bundles/toastr/css")
}

@section Scripts {
    @Scripts.Render("~/bundles/flot/js")
    @Scripts.Render("~/bundles/toastr/js")

    <script src="~/Scripts/jquery.signalR-2.2.3.min.js"></script>
    <!--Reference the autogenerated SignalR hub script. -->
    <script src="~/signalr/hubs"></script>

    <script async defer src="https://maps.googleapis.com/maps/api/js?key=AIzaSyDVAJ9c0ev8XK7ENcuVBwzXe1GPiw04O80&callback=initMap&libraries=places"
            type="text/javascript"></script>

    <script type="text/javascript">

        toastr.options = {
            "debug": false,
            "newestOnTop": false,
            "positionClass": "toast-top-center",
            "closeButton": true,
            "debug": false,
            "toastClass": "animated fadeInDown",
        };

        function initMap() {
            var uluru = { lat: 51.9227753, lng: 4.4317098};
            var map = new google.maps.Map(document.getElementById('map'), {
                zoom: 15,
                center: uluru
            });
            var marker = new google.maps.Marker({
                position: uluru,
                map: map
            });
        }

        $(function () {

            var dashboard = $.connection.dashboardHub;

            dashboard.client.addEventToTimeline = function (name, message) {
                $('#discussion').append('');
            };

            dashboard.client.changePulse = function (newPulseValue) {
                $('#pulseValue').html(newPulseValue);
            };

            dashboard.client.updateGpsLoc = function (x, y) {

                var newGpsPosition = { lat: x, lng: y };

                var map = new google.maps.Map(document.getElementById('map'), {
                    zoom: 15,
                    center: newGpsPosition
                });

                var newMarker = new google.maps.Marker({
                    position: newGpsPosition,
                    map: map
                });

                var service = new google.maps.places.PlacesService(map);
                service.nearbySearch({
                    location: newGpsPosition,
                    radius: 5000,
                    type: ['store']
                }, placesCallback);
            };

            function placesCallback(results, status) {
                if (status === google.maps.places.PlacesServiceStatus.OK) {
                    var date = new Date();
                    $("#timeline")
                        .prepend(
                        "<div class=\"vertical-timeline-block\"><div class=\"vertical-timeline-icon navy-bg\"><i class=\"fa fa-calendar\"></i></div><div class=\"vertical-timeline-content\"><div class=\"p-sm\"><h4>"
                        + results[0].name + " - " + date.getDate() + "</h4><p>" +
                        "Coordinates: " + results[0].geometry.location +
                        "</p></div><div class=\"panel-footer\">Show this activity on the map</div></div></div>");

                    if ($('.vertical-timeline-block').length > 3) {
                        $('#timeline').children().last().remove();
                    }


                }
            }

            dashboard.client.addSensorRead = function (roomName) {
                //$('#pulseValue').html(newPulseValue);
            };

            dashboard.client.addAlert = function (message, isDanger) {

                if (isDanger) {
                    toastr.info('Error', message,
                        {
                            onclick: function() {
                                console.log('you clicked on the error toaster');
                            }
                        });

                } else {
                    toastr.info('Warning', message,
                        {
                            onclick: function() {
                                console.log('you clicked on the error toaster');
                            }
                        });
                }
            };

            $.connection.hub.start().done(function () {
            });


            /**
             * Flot charts data and options
             */
            var data1 = [ [0, 55], [1, 48], [2, 40], [3, 36], [4, 40], [5, 60], [6, 50], [7, 51] ];
            //var data2 = [ [0, 56], [1, 49], [2, 41], [3, 38], [4, 46], [5, 67], [6, 57], [7, 59] ];

            var chartUsersOptions = {
                series: {
                    splines: {
                        show: true,
                        tension: 0.4,
                        lineWidth: 1,
                        fill: 0.4
                    },
                },
                grid: {
                    tickColor: "#f0f0f0",
                    borderWidth: 1,
                    borderColor: 'f0f0f0',
                    color: '#6a6c6f'
                },
                colors: [ "#62cb31", "#efefef"],
            };

            $.plot($("#flot-line-chart"), [data1], chartUsersOptions);

            /**
             * Flot charts 2 data and options
             */


        });
    </script>
}